package farbkreis;

import processing.core.*;


@SuppressWarnings("serial")
public class Farbkreis extends PApplet {

    float[] center = {100,100};
    float rInnen = 40;
    float rAussen = 80;
    float steps = 2*PI/765;
    int colorCount = 0;

    float phi = 0;

    public void setup ()
    {
        size( 200, 220 );
        background(0);
        key = '1';
        textFont(createFont("Arial", 16));
    }

    public void draw()
    {
        colorCount = colorCount % 765;
        float[] color = calculateColor(colorCount);
        colorCount += Integer.parseInt(""+key); //wenn >1 = regenbogeneffekt
        stroke(color[0], color[1], color[2]);
        fill(color[0], color[1], color[2]);
//        if (phi >= -2*PI)
//        {
            float[] pointA = {center[0]+((float)Math.cos(phi)*rInnen),center[1]+((float)Math.sin(phi)*rInnen)};
            float[] pointB = {center[0]+((float)Math.cos(phi)*rAussen),center[1]+((float)Math.sin(phi)*rAussen)};
            phi -= steps;
            float[] pointC = {center[0]+((float)Math.cos(phi)*rAussen),center[1]+((float)Math.sin(phi)*rAussen)};
            float[] pointD = {center[0]+((float)Math.cos(phi)*rInnen),center[1]+((float)Math.sin(phi)*rInnen)};
            quad(pointA[0], pointA[1], pointB[0], pointB[1], pointC[0], pointC[1], pointD[0], pointD[1]);

//        } else noLoop();

            fill(255,255,255);
            text("pres 1-9 for CD-Effect", 10, 210);
        
    }

    private float[] calculateColor(int val)
    {
        float r = (val <= 255)? 255-val:(val > 510)? val-510:0;
        float g = (val <= 255)? val:(val <= 510)? 510-val:0;
        float b = (val <= 510)? val - 255:(val > 510)? 255-(val-510):0;
        return new float[]{r,g,b};
    }
    
    


        public float[] RGBtoHSV(float r, float g, float b)
    {
        double R = r/255.0;
        double G = g/255.0;
        double B = b/255.0;

        double h = 0;  //Farbwinkel
        double s = 0; //Amplitude Farbartsignal
        double v = 0; //Helligkeit (nicht verwechseln mit Y)
        double rad = Math.PI*2.0;

        double max = Math.max(R, Math.max(G, B));
        double min = Math.min(R, Math.min(G, B));

        if (max == R) h = (60.0/360.0)*rad*(0+((G-B)/(max-min)));
        if (max == G) h = (60.0/360.0)*rad*(2.0+((B-R)/(max-min)));
        if (max == B) h = (60.0/360.0)*rad*(4.0+((R-G)/(max-min)));
        if (h<0) h = h + rad;

        if (!(R==G && R==B && B==G)) s = (max-min)/max;

        v = max;

        //from http://de.wikipedia.org/wiki/HSV-Farbraum
        return new float[]{(float)h,(float)s,(float)v};

    }

    public float[] hsvToRGB(float h, float s, float v)
    {
        double rad = Math.PI*2.0;
        double R = 0; double G = 0;double B = 0;

        int hi = (int)(h/(60.0/360.0*rad));
        double f = h/(60.0/360.0*rad)-(double)hi;

        double p = v*(1.0-s); double q = v*(1.0-s*f); double t = v*(1.0-s*(1.0-f));

        if (hi == 0) {R = v; G = t; B = p;}
        if (hi == 1) {R = q; G = v; B = p;}
        if (hi == 2) {R = p; G = v; B = t;}
        if (hi == 3) {R = p; G = q; B = v;}
        if (hi == 4) {R = t; G = p; B = v;}
        if (hi == 5) {R = v; G = p; B = q;}

        R *= 255.0;
        G *= 255.0;
        B *= 255.0;

        //from http://de.wikipedia.org/wiki/HSV-Farbraum
        return new float[]{(float)R,(float)G,(float)B};
    }

    
}
